#include <stdio.h>
#include "windos.h"

/*
 *
 * WinDOS()
 *
 * Copyright (C) 2011  moge32
 *
 * 16rbgx86@Bs܂B
 *
 */


// @B(x86 16bits)́B
// return (XLbv); ԂB
// Ƃꂢȃ\[XɎdグ(--;)
char parse(char *p)
{
	char tmp[1];
	short addr;

	if (*p == (char)NOP) { // XCHG AX,AXɂ
		return 1;
	}
	if (*p == (char)MOV_AX) {
		R_AX = p[2] * 0x100 + p[1];
		return 3;
	}
	if (*p == (char)MOV_AH) {
		R_AX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_AL) {
		R_AX = R_AH + p[1] & 0xff;
		return 2;
	}
	if (*p == (char)MOV_BX) {
		R_BX = p[2] * 0x100 + p[1];
		return 3;
	}
	if (*p == (char)MOV_BH) {
		R_BX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_BL) {
		R_BX = R_BH + p[1] & 0xff;
		return 2;
	}
	if (*p == (char)MOV_CX) {
		R_CX = p[2] * 0x100 + p[1];
		return 3;
	}
	if (*p == (char)MOV_CH) {
		R_CX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_CL) {
		R_CX = R_CH + p[1] & 0xff;
		return 2;
	}
	if (*p == (char)MOV_DX) {
		R_DX = p[2] * 0x100 + p[1];
		return 3;
	}
	if (*p == (char)MOV_DH) {
		R_DX = p[1] * 0x100;
		return 2;
	}
	if (*p == (char)MOV_DL) {
		R_DX = R_DH + p[1] & 0xff;
		return 2;
	}
	if (*p == (char)MOV_AX_P) {
		R_AX = address(p + 1);
		printf("MOV_AX_P: %04x\n", R_AX);
		return 3;
	}
	if (*p == (char)MOV_X_P) {	/* ኱oOH */
		char next = p[1];
		short addr = p[3] * 0x100 + p[2];
		if (next == (char) 0x0E) R_CX = addr;
		if (next == (char) 0x16) R_DX = addr;
		if (next == (char) 0x1E) R_BX = addr;
		if (next == (char) 0x26) R_SP = addr;
		if (next == (char) 0x2E) R_BP = addr;
		if (next == (char) 0x36) R_SI = addr;
		if (next == (char) 0x3E) R_DI = addr;
		// fobOR[h
		printf("MOV_X_P: %04x\n", addr);
		return 4;
	}
	if (*p == (char)MOV_X_X) {
		char next = p[1];
		movxx(next);
		return 2;
	}
	if (*p == (char)MOV_L_H) {
		char next = p[1];
		movlh(next);
		return 2;
	}
	if (*p == (char)XCHG_CX_AX) {
		xchg(&R_CX, &R_AX);
		return 2;
	}
	if (*p == (char)XCHG_DX_AX) {
		xchg(&R_DX, &R_AX);
		return 2;
	}
	if (*p == (char)XCHG_BX_AX) {
		xchg(&R_BX, &R_AX);
		return 2;
	}
	if (*p == (char)XCHG_X) {
		char next = p[1];
		xchgx(next);
		return 2;
	}
	if (*p == (char)INT3) {
		return interrupt(p + 1);
	}
	if (*p == (char)INT) {
		return interrupt(p + 1);
	}
	if (*p == (char)JMP) {
		return 1 + p[1];
	}

	return 0;
}

// INT̏
int interrupt(char *call)
{
	if (*call == INT_BRK) {	// int03
		printf("windos: [breakpoint]@int3");
		end(-1);
	}
	if (*call == INT_END) {	// int20
		end(4);
	}
	if (*call == INT_API) { // int21
		msdos_api(call);
	}
	return 2;
}

// ȉ̃\[XɂuNOTHINGv͈Ӗ̂Ȃ킷RgłB

// XCHG_X̏
void xchgx(char next)
{
	if (next == (char) 0xC0) /* NOTHING */;
	if (next == (char) 0xC1) xchg(&R_AX, &R_CX);
	if (next == (char) 0xC2) xchg(&R_AX, &R_DX);
	if (next == (char) 0xC3) xchg(&R_AX, &R_BX);
	if (next == (char) 0xC4) xchg(&R_AX, &R_SP);
	if (next == (char) 0xC5) xchg(&R_AX, &R_BP);
	if (next == (char) 0xC6) xchg(&R_AX, &R_SI);
	if (next == (char) 0xC7) xchg(&R_AX, &R_DI);
	if (next == (char) 0xC8) xchg(&R_CX, &R_AX);
	if (next == (char) 0xC9) /* NOTHING */;
	if (next == (char) 0xCA) xchg(&R_CX, &R_DX);
	if (next == (char) 0xCB) xchg(&R_CX, &R_BX);
	if (next == (char) 0xCC) xchg(&R_CX, &R_SP);
	if (next == (char) 0xCD) xchg(&R_CX, &R_BP);
	if (next == (char) 0xCE) xchg(&R_CX, &R_SI);
	if (next == (char) 0xCF) xchg(&R_CX, &R_DI);
	if (next == (char) 0xD0) xchg(&R_DX, &R_AX);
	if (next == (char) 0xD1) xchg(&R_DX, &R_CX);
	if (next == (char) 0xD2) /* NOTHING */;
	if (next == (char) 0xD3) xchg(&R_DX, &R_BX);
	if (next == (char) 0xD4) xchg(&R_DX, &R_SP);
	if (next == (char) 0xD5) xchg(&R_DX, &R_BP);
	if (next == (char) 0xD6) xchg(&R_DX, &R_SI);
	if (next == (char) 0xD7) xchg(&R_DX, &R_DI);
	if (next == (char) 0xD8) xchg(&R_BX, &R_AX);
	if (next == (char) 0xD9) xchg(&R_BX, &R_CX);
	if (next == (char) 0xDA) xchg(&R_BX, &R_DX);
	if (next == (char) 0xDB) /* NOTHING */;
	if (next == (char) 0xDC) xchg(&R_BX, &R_SP);
	if (next == (char) 0xDD) xchg(&R_BX, &R_BP);
	if (next == (char) 0xDE) xchg(&R_BX, &R_SI);
	if (next == (char) 0xDF) xchg(&R_BX, &R_DI);
	if (next == (char) 0xE0) xchg(&R_SP, &R_AX);
	if (next == (char) 0xE1) xchg(&R_SP, &R_CX);
	if (next == (char) 0xE2) xchg(&R_SP, &R_DX);
	if (next == (char) 0xE3) xchg(&R_SP, &R_BX);
	if (next == (char) 0xE4) /* NOTHING */;
	if (next == (char) 0xE5) xchg(&R_SP, &R_BP);
	if (next == (char) 0xE6) xchg(&R_SP, &R_SI);
	if (next == (char) 0xE7) xchg(&R_SP, &R_DI);
	if (next == (char) 0xE8) xchg(&R_BP, &R_AX);
	if (next == (char) 0xE9) xchg(&R_BP, &R_CX);
	if (next == (char) 0xEA) xchg(&R_BP, &R_DX);
	if (next == (char) 0xEB) xchg(&R_BP, &R_BX);
	if (next == (char) 0xEC) xchg(&R_BP, &R_SP);
	if (next == (char) 0xED) /* NOTHING */;
	if (next == (char) 0xEE) xchg(&R_BP, &R_SI);
	if (next == (char) 0xEF) xchg(&R_BP, &R_DI);
	if (next == (char) 0xF0) xchg(&R_SI, &R_AX);
	if (next == (char) 0xF1) xchg(&R_SI, &R_CX);
	if (next == (char) 0xF2) xchg(&R_SI, &R_DX);
	if (next == (char) 0xF3) xchg(&R_SI, &R_BX);
	if (next == (char) 0xF4) xchg(&R_SI, &R_SP);
	if (next == (char) 0xF5) xchg(&R_SI, &R_BP);
	if (next == (char) 0xF6) /* NOTHING */;
	if (next == (char) 0xF7) xchg(&R_SI, &R_DI);
	if (next == (char) 0xF8) xchg(&R_DI, &R_AX);
	if (next == (char) 0xF9) xchg(&R_DI, &R_CX);
	if (next == (char) 0xFA) xchg(&R_DI, &R_DX);
	if (next == (char) 0xFB) xchg(&R_DI, &R_BX);
	if (next == (char) 0xFC) xchg(&R_DI, &R_SP);
	if (next == (char) 0xFD) xchg(&R_DI, &R_BP);
	if (next == (char) 0xFE) xchg(&R_DI, &R_SI);
	if (next == (char) 0xFF) /* NOTHING */;
	return;
}

// MOV_X_X̏
void movxx(char next)
{
	if (next == (char) 0xC0) /* NOTHING */;
	if (next == (char) 0xC1) R_CX = R_AX;
	if (next == (char) 0xC2) R_DX = R_AX;
	if (next == (char) 0xC3) R_BX = R_AX;
	if (next == (char) 0xC4) R_SP = R_AX;
	if (next == (char) 0xC5) R_BP = R_AX;
	if (next == (char) 0xC6) R_SI = R_AX;
	if (next == (char) 0xC7) R_DI = R_AX;
	if (next == (char) 0xC8) R_AX = R_CX;
	if (next == (char) 0xC9) /* NOTHING */;
	if (next == (char) 0xCA) R_DX = R_CX;
	if (next == (char) 0xCB) R_BX = R_CX;
	if (next == (char) 0xCC) R_SP = R_CX;
	if (next == (char) 0xCD) R_BP = R_CX;
	if (next == (char) 0xCE) R_SI = R_CX;
	if (next == (char) 0xCF) R_DI = R_CX;
	if (next == (char) 0xD0) R_AX = R_DX;
	if (next == (char) 0xD1) R_CX = R_DX;
	if (next == (char) 0xD2) /* NOTHING */;
	if (next == (char) 0xD3) R_BX = R_DX;
	if (next == (char) 0xD4) R_SP = R_DX;
	if (next == (char) 0xD5) R_BP = R_DX;
	if (next == (char) 0xD6) R_SI = R_DX;
	if (next == (char) 0xD7) R_DI = R_DX;
	if (next == (char) 0xD8) R_CX = R_BX;
	if (next == (char) 0xD9) R_AX = R_BX;
	if (next == (char) 0xDA) R_DX = R_BX;
	if (next == (char) 0xDB) /* NOTHING */;
	if (next == (char) 0xDC) R_SP = R_BX;
	if (next == (char) 0xDD) R_BP = R_BX;
	if (next == (char) 0xDE) R_SI = R_BX;
	if (next == (char) 0xDF) R_DI = R_BX;
	if (next == (char) 0xE0) R_AX = R_SP;
	if (next == (char) 0xE1) R_CX = R_SP;
	if (next == (char) 0xE2) R_DX = R_SP;
	if (next == (char) 0xE3) R_BX = R_SP;
	if (next == (char) 0xE4) /* NOTHING */;
	if (next == (char) 0xE5) R_BP = R_SP;
	if (next == (char) 0xE6) R_SI = R_SP;
	if (next == (char) 0xE7) R_DI = R_SP;
	if (next == (char) 0xE8) R_AX = R_BP;
	if (next == (char) 0xE9) R_CX = R_BP;
	if (next == (char) 0xEA) R_DX = R_BP;
	if (next == (char) 0xEB) R_BX = R_BP;
	if (next == (char) 0xEC) R_SP = R_BP;
	if (next == (char) 0xED) /* NOTHING */;
	if (next == (char) 0xEE) R_SI = R_BP;
	if (next == (char) 0xEF) R_DI = R_BP;
	if (next == (char) 0xF0) R_AX = R_SI;
	if (next == (char) 0xF1) R_CX = R_SI;
	if (next == (char) 0xF2) R_DX = R_SI;
	if (next == (char) 0xF3) R_BX = R_SI;
	if (next == (char) 0xF4) R_SP = R_SI;
	if (next == (char) 0xF5) R_BP = R_SI;
	if (next == (char) 0xF6) /* NOTHING */;
	if (next == (char) 0xF7) R_DI = R_SI;
	if (next == (char) 0xF8) R_AX = R_DI;
	if (next == (char) 0xF9) R_CX = R_DI;
	if (next == (char) 0xFA) R_DX = R_DI;
	if (next == (char) 0xFB) R_BX = R_DI;
	if (next == (char) 0xFC) R_SP = R_DI;
	if (next == (char) 0xFD) R_BP = R_DI;
	if (next == (char) 0xFE) R_SI = R_DI;
	if (next == (char) 0xFF) /* NOTHING */;
	return;
}

// MOV_L_H̏
void movlh(char next)
{
	if (next == (char) 0xC0) /* NOTHING */;
	if (next == (char) 0xC1) REG_L(R_CX, R_CL, R_AL);
	if (next == (char) 0xC2) REG_L(R_DX, R_DL, R_AL);
	if (next == (char) 0xC3) REG_L(R_BX, R_BL, R_AL);
	if (next == (char) 0xC4) REG_H(R_AX, R_AH, R_AL);
	if (next == (char) 0xC5) REG_H(R_CX, R_CH, R_AL);
	if (next == (char) 0xC6) REG_H(R_DX, R_DH, R_AL);
	if (next == (char) 0xC7) REG_H(R_BX, R_BH, R_AL);
	if (next == (char) 0xC8) REG_L(R_AX, R_AL, R_CL);
	if (next == (char) 0xC9) /* NOTHING */;
	if (next == (char) 0xCA) REG_L(R_DX, R_DL, R_CL);
	if (next == (char) 0xCB) REG_L(R_BX, R_BL, R_CL);
	if (next == (char) 0xCC) REG_H(R_AX, R_AH, R_CL);
	if (next == (char) 0xCD) REG_H(R_CX, R_CH, R_CL);
	if (next == (char) 0xCE) REG_H(R_DX, R_DH, R_CL);
	if (next == (char) 0xCF) REG_H(R_BX, R_BH, R_CL);
	if (next == (char) 0xD0) REG_L(R_AX, R_AL, R_DL);
	if (next == (char) 0xD1) REG_L(R_CX, R_CL, R_DL);
	if (next == (char) 0xD2) /* NOTHING */;
	if (next == (char) 0xD3) REG_L(R_BX, R_BL, R_DL);
	if (next == (char) 0xD4) REG_H(R_AX, R_AH, R_DL);
	if (next == (char) 0xD5) REG_H(R_CX, R_CH, R_DL);
	if (next == (char) 0xD6) REG_H(R_DX, R_DH, R_DL);
	if (next == (char) 0xD7) REG_H(R_BX, R_BH, R_DL);
	if (next == (char) 0xD8) REG_L(R_AX, R_AL, R_BL);
	if (next == (char) 0xD9) REG_L(R_CX, R_CL, R_BL);
	if (next == (char) 0xDA) REG_L(R_DX, R_DL, R_BL);
	if (next == (char) 0xDB) /* NOTHING */;
	if (next == (char) 0xDC) REG_H(R_AX, R_AH, R_BL);
	if (next == (char) 0xDD) REG_H(R_CX, R_CH, R_BL);
	if (next == (char) 0xDE) REG_H(R_DX, R_DH, R_BL);
	if (next == (char) 0xDF) REG_H(R_BX, R_BH, R_BL);
	if (next == (char) 0xE0) REG_L(R_AX, R_AL, R_AH);
	if (next == (char) 0xE1) REG_L(R_CX, R_CL, R_AH);
	if (next == (char) 0xE2) REG_L(R_DX, R_DL, R_AH);
	if (next == (char) 0xE3) REG_L(R_BX, R_BL, R_AH);
	if (next == (char) 0xE4) /* NOTHING */;
	if (next == (char) 0xE5) REG_H(R_CX, R_CH, R_AH);
	if (next == (char) 0xE6) REG_H(R_DX, R_DH, R_AH);
	if (next == (char) 0xE7) REG_H(R_BX, R_BH, R_AH);
	if (next == (char) 0xE8) REG_L(R_AX, R_AL, R_CH);
	if (next == (char) 0xE9) REG_L(R_CX, R_CL, R_CH);
	if (next == (char) 0xEA) REG_L(R_DX, R_DL, R_CH);
	if (next == (char) 0xEB) REG_L(R_BX, R_BL, R_CH);
	if (next == (char) 0xEC) REG_H(R_AX, R_AH, R_CH);
	if (next == (char) 0xED) /* NOTHING */;
	if (next == (char) 0xEE) REG_H(R_DX, R_DH, R_CH);
	if (next == (char) 0xEF) REG_H(R_BX, R_BH, R_CH);
	if (next == (char) 0xF0) REG_L(R_AX, R_AL, R_DH);
	if (next == (char) 0xF1) REG_L(R_CX, R_CL, R_DH);
	if (next == (char) 0xF2) REG_L(R_DX, R_DL, R_DH);
	if (next == (char) 0xF3) REG_L(R_BX, R_BL, R_DH);
	if (next == (char) 0xF4) REG_H(R_AX, R_AH, R_DH);
	if (next == (char) 0xF5) REG_H(R_CX, R_CH, R_DH);
	if (next == (char) 0xF6) /* NOTHING */;
	if (next == (char) 0xF7) REG_H(R_BX, R_BH, R_DH);
	if (next == (char) 0xF8) REG_L(R_AX, R_AL, R_BH);
	if (next == (char) 0xF9) REG_L(R_CX, R_CL, R_BH);
	if (next == (char) 0xFA) REG_L(R_DX, R_DL, R_BH);
	if (next == (char) 0xFB) REG_L(R_BX, R_BL, R_BH);
	if (next == (char) 0xFC) REG_H(R_AX, R_AH, R_BH);
	if (next == (char) 0xFD) REG_H(R_CX, R_CH, R_BH);
	if (next == (char) 0xFE) REG_H(R_DX, R_DH, R_BH);
	if (next == (char) 0xFF) /* NOTHING */;

	return;
}

// lւ(short)
void xchg(short *a, short *b)
{
	short t = *a;
	*a = *b;
	*b = t;
	return;
}

// lւ(char)
void xchg_ch(char *a, char *b)
{
	char t = *a;
	*a = *b;
	*b = t;
	return;
}

// Intelzcharshortl
short address(char *p)
{
	return p[1] * 0x100 + p[0];
}

void unknown()
{
	// p: WinDOS(temp) CPU has encountered an illegal instruction.
	puts("WinDOS()CPU͕s߂o܂B");	// MSNTVDM̂܂ˁB
	return;
}


/* end of x86.c */
